<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingezautos extends JPlugin{

	var $searchFields = array('ez_model.name', 'ez_cat.name', 'ez_make.name', 'ez_auto.year');
	var $selectedFields = array('ez_auto.*', 'ez_cat.*', 'ez_make.*', 'ez_auto.id as autoid', 'ez_model.name as modelname', 'ez_cat.name as catname', 'ez_make.name as makename');
	var $Itemid = '';

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'ezauto');
			$this->params = new acyParameter($plugin->params);
		}
		$this->db = JFactory::getDBO();
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
	}

	function acymailing_getPluginType(){
		$onePlugin = new stdClass();
		$onePlugin->name = 'EZ Autos';
		$onePlugin->function = 'acymailingezauto_show';
		$onePlugin->help = 'plugin-ezauto';

		return $onePlugin;
	}

	function acymailingezauto_show(){
		$config = acymailing_config();
		if($config->get('version') < '5.2.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}
		$lang = JFactory::getLanguage();
		$lang->load('com_ezautos', JPATH_SITE);
		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.ezauto';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest($paramBase.".filter_order", 'filter_order', 'ez_auto.id', 'cmd');
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest($paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->contenttype = $app->getUserStateFromRequest($paramBase.".contenttype", 'contenttype', '|type:full', 'string');
		$pageInfo->lang = $app->getUserStateFromRequest($paramBase.".lang", 'lang', '', 'string');
		$pageInfo->contenttypeauto = $app->getUserStateFromRequest($paramBase.".contenttypeauto", 'contenttypeauto', '|type:full', 'string');
		$pageInfo->langauto = $app->getUserStateFromRequest($paramBase.".langauto", 'langauto', '', 'string');
		$pageInfo->titlelink = $app->getUserStateFromRequest($paramBase.".titlelink", 'titlelink', $this->params->get('default_titlelink', '|link'), 'string');
		$pageInfo->filter_cat = $app->getUserStateFromRequest($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->filter_make = $app->getUserStateFromRequest($paramBase.".filter_make", 'filter_make', '', 'int');
		$pageInfo->pict = $app->getUserStateFromRequest($paramBase.".pict", 'pict', 1, 'string');
		$pageInfo->pictheight = $app->getUserStateFromRequest($paramBase.".pictheight", 'pictheight', 150, 'string');
		$pageInfo->pictwidth = $app->getUserStateFromRequest($paramBase.".pictwidth", 'pictwidth', 150, 'string');

		$pageInfo->limit->value = $app->getUserStateFromRequest($paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest($paramBase.'.limitstart', 'limitstart', 0, 'int');

		$db = JFactory::getDBO();

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $this->searchFields)." LIKE $searchVal";
		}

		if(!empty($pageInfo->filter_cat)){
			$filters[] = "ez_cat.id = ".intval($pageInfo->filter_cat);
		}
		if(!empty($pageInfo->filter_make)){
			$filters[] = "ez_make.id = ".intval($pageInfo->filter_make);
		}

		$whereQuery = '';
		if(!empty($filters)){
			$whereQuery = ' WHERE ('.implode(') AND (', $filters).')';
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS '.implode(',', $this->selectedFields).' FROM `#__ezautos` as ez_auto ';
		$query .= 'JOIN `#__ezautos_catg` as ez_cat ON ez_cat.id = ez_auto.cid ';
		$query .= 'JOIN `#__ezautos_make` AS ez_make ON ez_make.id = ez_auto.maid ';
		$query .= 'JOIN `#__ezautos_model` AS ez_model ON ez_auto.moid = ez_model.id';


		if(!empty($whereQuery)){
			$query .= $whereQuery.' AND ez_auto.published = "1"';
		}else $query .= ' WHERE ez_auto.published = "1"';
		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}


		$db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search, $rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		$picts = array();
		$picts[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$pictureHelper = acymailing_get('helper.acypict');
		if($pictureHelper->available()) $picts[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$picts[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$db->setQuery('SELECT id, name FROM `#__ezautos_catg`');
		$categories = $db->loadObjectList('id');
		$categoriesValues = array();
		$categoriesValues[] = JHTML::_('select.option', '', JText::_('ACY_ALL'));
		foreach($categories as $catid => $oneCategorie){
			$categoriesValues[] = JHTML::_('select.option', $catid, $oneCategorie->name);
		}
		$db->setQuery('SELECT id, name FROM `#__ezautos_make`');
		$makes = $db->loadObjectList('id');
		$makesValues = array();
		$makesValues[] = JHTML::_('select.option', '', JText::_('ACY_ALL'));
		foreach($makes as $makeid => $onemake){
			$makesValues[] = JHTML::_('select.option', $makeid, $onemake->name);
		}
		$contenttype = array('title' => 'ACY_TITLE', 'price' => 'EZAUTOS_DET_PRICE', 'details' => 'ACY_DETAILS', 'short_intro' => 'EZAUTOS_VLDET_SDESC', 'long_intro' => 'EZAUTOS_VLDET_LDESC');

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('ezauto_tab');
		echo $tabs->startPanel('EZ Autos', 'autos');

		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			var selectedDisplay = new Array();

			function applyAuto(autoid, rowClass){
				if(selectedContents[autoid]){
					window.document.getElementById('content' + autoid).className = rowClass;
					delete selectedContents[autoid];
				}else{
					window.document.getElementById('content' + autoid).className = 'selectedrow';
					selectedContents[autoid] = 'content';
				}

				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';

				otherinfo += '| type:';
				for(var i = 0; i < document.adminForm.contenttype.length; i++){
					if(document.adminForm.contenttype[i].checked){
						otherinfo += document.adminForm.contenttype[i].value + ',';
					}
				}

				for(var i = 0; i < document.adminForm.pict.length; i++){
					if(document.adminForm.pict[i].checked){
						otherinfo += '| pict:' + document.adminForm.pict[i].value;
						if(document.adminForm.pict[i].value == 'resized'){
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				if(window.document.getElementById('jflang') && window.document.getElementById('jflang').value != ''){
					otherinfo += '| lang:' + window.document.getElementById('jflang').value;
				}

				if(document.adminForm.cols && document.adminForm.cols.value > 1){
					otherinfo += '| cols:' + document.adminForm.cols.value;
				}

				for(var i in selectedContents){
					if(selectedContents[i] == 'content'){
						tag += '{ezautos:' + i + otherinfo + '}<br />';
					}
				}

				setTag(tag);
			}

			//-->
		</script>
		<br style="font-size:1px"/>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<td>
						<?php echo JText::_('DISPLAY'); ?>
					</td>
					<td colspan="2">
						<?php foreach($contenttype as $oneContent => $trad){ ?>
							<label for="type<?php echo $oneContent ?>"><input style="float:none;" type="checkbox" checked="checked" name="contenttype" id="type<?php echo $oneContent ?>" value="<?php echo $oneContent ?>" size="1" onclick="updateTag();"/><?php echo JText::_($trad); ?></label>
						<?php } ?>
					</td>
					<td>
						<?php $jflanguages = acymailing_get('type.jflanguages');
						$jflanguages->onclick = 'onchange="updateTag();"';
						echo $jflanguages->display('lang', $pageInfo->lang); ?>
					</td>
				</tr>
				<tr>
					<td valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
					<td valign="top" colspan="3"><?php echo JHTML::_('acyselect.radiolist', $picts, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
						<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?>><br/><?php echo JText::_('CAPTCHA_WIDTH') ?>
							<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
							x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
							<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
						</span>
					</td>
				</tr>
			</table>
		</div>
		<div class="onelineblockoptions">
			<table class="acymailing_table_options">
				<tr>
					<td width="100%">
						<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search; ?>" class="text_area" onchange="document.adminForm.submit();"/>
						<button class="acymailing_button_grey" onclick="this.form.submit();"><?php echo JText::_('JOOMEXT_GO'); ?></button>
						<button class="acymailing_button_grey" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_('JOOMEXT_RESET'); ?></button>
					</td>
					<td nowrap="nowrap">
						<?php echo JHTML::_('select.genericlist', $categoriesValues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int)$pageInfo->filter_cat); ?>
					</td>
					<td nowrap="nowrap">
						<?php echo JHTML::_('select.genericlist', $makesValues, 'filter_make', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int)$pageInfo->filter_make); ?>
					</td>

				</tr>
			</table>

			<table class="acymailing_table" cellpadding="1" width="100%">
				<thead>
				<tr>
					<th class="title">
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('ACY_YEAR'), 'ez_auto.year', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('EZAUTOS_SEARCH_MAKE'), 'ez_make.name', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('EZAUTOS_SEARCH_MODEL'), 'ez_model.name', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('EZAUTOS_CATEGORY_CATNAME'), 'ez_cat.name', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'ez_auto.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
				</tr>
				</thead>
				<tfoot>
				<tr>
					<td colspan="6">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
				</tfoot>
				<tbody>
				<?php
				$k = 0;
				for($i = 0, $a = count($rows); $i < $a; $i++){
					$row =& $rows[$i];
					?>
					<tr id="content<?php echo $row->autoid; ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $row->autoid ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
							<?php echo $row->year; ?>
						</td>
						<td>
							<?php echo $row->makename; ?>
						</td>
						<td>
							<?php echo $row->modelname; ?>
						</td>
						<td>
							<?php echo $row->catname; ?>
						</td>
						<td align="center" style="text-align:center">
							<?php echo $row->autoid; ?>
						</td>
					</tr>
					<?php
					$k = 1 - $k;
				}
				?>
				</tbody>
			</table>
		</div>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php
		echo $tabs->endPanel();
		echo $tabs->startPanel(JText::_('TAG_CATEGORIES'), 'Categories');
		$type = JRequest::getString('type');

		?>
		<br style="font-size:1px"/>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedCat = new Array();
			function applyAutoCars(catid, rowClass){
				if(selectedCat[catid]){
					window.document.getElementById('auto_cat' + catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('auto_cat' + catid).className = 'selectedrow';
					selectedCat[catid] = 'content';
				}

				updateAutoTag();
			}

			function updateAutoTag(){
				var tag = '{autoez:';
				var otherinfo = '';

				for(var icat in selectedCat){
					if(selectedCat[icat] == 'content'){
						tag += icat + '-';
					}
				}
				tag += '| autotype:';
				for(var i = 0; i < document.adminForm.autocontenttype.length; i++){
					if(document.adminForm.autocontenttype[i].checked){
						tag += document.adminForm.autocontenttype[i].value + ',';
					}
				}

				for(var i = 0; i < document.adminForm.pictauto.length; i++){
					if(document.adminForm.pictauto[i].checked){
						tag += '| pict:' + document.adminForm.pictauto[i].value;
						if(document.adminForm.pictauto[i].value == 'resized'){
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) tag += '| maxwidth:' + document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) tag += '| maxheight:' + document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				if(window.document.getElementById('jflang') && window.document.getElementById('jflang').value != ''){
					tag += '| lang:';
					tag += window.document.getElementById('jflang').value;
				}
				if(document.adminForm.automake.value && document.adminForm.automake.value != 0){
					tag += '| make:' + document.adminForm.automake.value;
				}
				if(document.adminForm.max_article.value && document.adminForm.max_article.value != 0){
					tag += '| max:' + document.adminForm.max_article.value;
				}
				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value != 0){
					tag += '| min:' + document.adminForm.min_article.value;
				}
				if(document.adminForm.autocols && document.adminForm.autocols.value > 1){
					tag += '| cols:' + document.adminForm.autocols.value;
				}
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
					tag += document.adminForm.contentfilter.value;
				}
				if(document.adminForm.contentorder.value){
					tag += "| order:" + document.adminForm.contentorder.value + "," + document.adminForm.contentorderdir.value;
				}
				tag += '}<br />';
				setTag(tag);
			}
			//-->
		</script>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<td>
						<?php echo JText::_('DISPLAY'); ?>
					</td>
					<td colspan="2">
						<?php foreach($contenttype as $oneContent => $trad){ ?>
							<label for="autotype<?php echo $oneContent ?>"><input style="float:none;" checked="checked" type="checkbox" name="autocontenttype" id="autotype<?php echo $oneContent ?>" value="<?php echo $oneContent ?>" size="1" onclick="updateAutoTag();"/><?php echo JText::_($trad); ?></label>
						<?php } ?>
					</td>
					<td>
						<?php $jflanguages = acymailing_get('type.jflanguages');
						$jflanguages->onclick = 'onchange="updateAutoTag();"';
						echo $jflanguages->display('lang', $pageInfo->lang); ?>
					</td>
				</tr>
				<tr>
					<td valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
					<td valign="top" colspan="3"><?php echo JHTML::_('acyselect.radiolist', $picts, 'pictauto', 'size="1" onclick="updateAutoTag();"', 'value', 'text', $this->params->get('default_pict', '1')); ?>
						<span id="pictsizeauto" style="display:none;"><br/><?php echo JText::_('CAPTCHA_WIDTH') ?>
							<input name="pictwidthauto" type="text" onchange="updateAutoTag();" value="150" style="width:30px;"/>
							x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
							<input name="pictheightauto" type="text" onchange="updateAutoTag();" value="150" style="width:30px;"/>
						</span>
					</td>
				</tr>
				<tr>
					<td><?php echo JText::_('FIELD_COLUMNS') ?></td>
					<td><input type="text" name="autocols" style="width:50px" value="1" onchange="updateAutoTag();"/></td>
					<td>
						<?php echo JText::_('ACY_ORDER'); ?>
					</td>
					<td>
						<?php
						$values = array('id' => 'ACY_ID', 'ordering' => 'ACY_ORDERING', 'listdate' => 'CREATED_DATE', 'lastupdate' => 'MODIFIED_DATE');
						echo $this->acypluginsHelper->getOrderingField($values, 'id', 'DESC', 'updateAutoTag');
						?>
					</td>
				</tr>
				<tr>
					<td>
						<?php echo JText::_('MAX_ARTICLE'); ?>
					</td>
					<td>
						<input type="text" name="max_article" style="width:50px" value="20" onchange="updateAutoTag();"/>
					</td>
					<td>
						<?php echo JText::_('EZAUTOS_SEARCH_MAKE'); ?>
					</td>
					<td>
						<?php echo JHTML::_('select.genericlist', $makesValues, 'automake', 'size="1" onchange="updateAutoTag();"'); ?>
					</td>
				</tr>
				<?php if($type == 'autonews'){ ?>
					<tr>
						<td>
							<?php echo JText::_('MIN_ARTICLE'); ?>
						</td>
						<td>
							<input type="text" name="min_article" style="width:50px" value="1" onchange="updateAutoTag();"/>
						</td>
						<td>
							<?php echo JText::_('JOOMEXT_FILTER'); ?>
						</td>
						<td>
							<?php $filter = acymailing_get('type.contentfilter');
							$filter->onclick = "updateAutoTag();";
							echo $filter->display('contentfilter', '|filter:created'); ?>
						</td>
					</tr>
				<?php } ?>
			</table>
		</div>
		<div class="onelineblockoptions">
			<table class="acymailing_table" cellpadding="1" width="100%">
				<?php $k = 0;
				foreach($categories as $oneCat){ ?>
					<tr id="auto_cat<?php echo $oneCat->id ?>" class="<?php echo "row$k"; ?>" onclick="applyAutoCars(<?php echo $oneCat->id ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
							<?php
							echo $oneCat->name;
							?>
						</td>
					</tr>
					<?php $k = 1 - $k;
				} ?>
			</table>
		</div>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
		//End of the function
	}

	function acymailing_replacetags(&$email, $send = true){
		$this->_replaceAuto($email);
		$this->_replaceCars($email);
	}

	private function _replaceCars(&$email){
		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, 'ezautos');
		if(empty($tags)) return;

		//Set the read more link:
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img class="readmorepict" src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE', true).'" />';

		$this->db->setQuery("SELECT * from #__menu  WHERE link = 'index.php?option=com_ezautos' or link='index.php?option=com_ezautos&view=ezautos'");
		$this->Itemid = '&Itemid'.$this->db->loadResult();

		$lang = JFactory::getLanguage();
		$lang->load('com_ezautos', JPATH_SITE);

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceCar($oneTag);
		}

		$this->acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	function _replaceCar($tag){
		$app = JFactory::getApplication();

		if(empty($tag->type)) return;

		//1 : Load the informations of the product...
		$query = 'SELECT ez_auto.*, ez_cat.*, ez_make.*, ez_auto.id as autoid, ez_model.name as modelname, ez_cat.name as catname, ez_make.name as makename, ez_engine.name as enginename ';
		$query .= 'FROM `#__ezautos` as ez_auto ';
		$query .= 'JOIN `#__ezautos_catg` as ez_cat ON ez_cat.id = ez_auto.cid ';
		$query .= 'JOIN `#__ezautos_make` AS ez_make ON ez_make.id = ez_auto.maid ';
		$query .= 'JOIN `#__ezautos_model` AS ez_model ON ez_auto.moid = ez_model.id ';
		$query .= 'LEFT JOIN `#__ezautos_enginesize` AS ez_engine ON ez_auto.engine = ez_engine.id ';
		$query .= 'WHERE ez_auto.id = '.intval($tag->id).' AND ez_auto.published = "1"';

		$this->db->setQuery($query);
		$auto = $this->db->loadObject();
		if(empty($auto)){
			if($app->isAdmin()) $app->enqueueMessage('The Ez auto "'.$tag->id.'" could not be loaded', 'notice');
			return '';
		}

		$varFields = array();
		foreach($auto as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		$link = acymailing_frontendLink('index.php?option=com_ezautos&view=ezautos&id='.$auto->autoid.$this->Itemid);
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content">';
		$price = '';
		$types = explode(',', $tag->type);


		if(!empty($auto->showprice) && in_array('price', $types)){
			if($auto->freq == 1){
				$frequency = JText::_('EZAUTOS_RENTAL_DAILY').'</br>';
			}elseif($auto->freq == 2) $frequency = JText::_('EZAUTOS_RENTAL_WEEKLY').'</br>';
			elseif($auto->freq == 3) $frequency = JText::_('EZAUTOS_RENTAL_FNIGHT').'</br>';
			elseif($auto->freq == 4) $frequency = JText::_('EZAUTOS_RENTAL_MONTH').'</br>';
			else $frequency = '';

			$currency = $this->params->get('currency');
			if($currency == 'EUR'){
				$price = number_format($auto->price, 2, ',', ' ').' €';
			}else{
				//Default is USD
				$price = '$'.number_format($auto->price, 2, '.', '');
			}

			if($auto->type == 2 || $auto->type == 3) $price .= ' '.$frequency;
		}

		if(in_array('title', $types)){
			$result .= '<a style="text-decoration:none;" name="auto-'.$auto->autoid.'" target="_blank" href="'.$link.'"><h2 class="acymailing_title">'.$auto->makename.'&nbsp;'.$auto->modelname.'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$price.'</h2></a>';
		}

		$result .= '<table><tr><td>';
		if(!empty($tag->pict)){
			$this->db->setQuery('SELECT fname FROM #__ezautos_images WHERE propid = '.intval($tag->id).' ORDER BY ordering ASC');
			$image = $this->db->loadResult();

			if(!empty($image) && file_exists(ACYMAILING_ROOT.'images/ezautos/listings/'.$image)){
				$varFields['{picture}'] = '<img src="images/ezautos/listings/'.$image.'" alt="" style="margin:5px; float:left;" />';
				$result .= $varFields['{picture}'];
			}
		}

		if(in_array('short_intro', $types)){
			if(!empty($auto->smalldesc)) $result .= '<p>'.nl2br($auto->smalldesc).'</p>';
		}

		if(in_array('long_intro', $types)){
			if(!empty($auto->longdesc)) $result .= '<p>'.$auto->longdesc.'</p>';
		}

		$result .= '</td></tr>';
		if(in_array('details', $types)){
			$details = '<tr><td>';
			$details .= JText::_('EZAUTOS_YEARONLY').' : '.($auto->year).'<br />';
			$details .= JText::_('EZAUTOS_CATEGORY_CATNAME').' : '.($auto->catname).'<br />';
			$details .= JText::_('EZAUTOS_VLDET_MAKE').' : '.($auto->makename).'<br />';
			$details .= JText::_('EZAUTOS_VLDET_MODEL').' : '.($auto->modelname).'<br />';


			if($auto->type == 1){
				$details .= JText::_('EZAUTOS_DET_CONDITION').' : '.JText::_('EZAUTOS_TYPE_SALE').'<br />';
			}elseif($auto->type == 2) $details .= JText::_('EZAUTOS_DET_CONDITION').' : '.JText::_('EZAUTOS_TYPE_RENTAL').'<br />';
			elseif($auto->type == 3) $details .= JText::_('EZAUTOS_DET_CONDITION').' : '.JText::_('EZAUTOS_TYPE_LEASE').'<br />';
			elseif($auto->type == 4) $details .= JText::_('EZAUTOS_DET_CONDITION').' : '.JText::_('EZAUTOS_TYPE_AUCTION').'<br />';
			elseif($auto->type == 5) $details .= JText::_('EZAUTOS_DET_CONDITION').' : '.JText::_('EZAUTOS_TYPE_SWAP').'<br />';
			elseif($auto->type == 6) $details .= JText::_('EZAUTOS_DET_CONDITION').' : '.JText::_('EZAUTOS_TYPE_TENDER').'<br />';


			if($auto->availability == 1){
				$details .= JText::_('EZAUTOS_CATEGORY_CATNAME').' : '.JText::_('EZAUTOS_AVAIL_AV').'<br />';
			}elseif($auto->availability == 2){
				$details .= JText::_('EZAUTOS_CATEGORY_CATNAME').' : '.JText::_('EZAUTOS_AVAIL_UC').'<br />';
			}elseif($auto->availability == 3){
				$details .= JText::_('EZAUTOS_CATEGORY_CATNAME').' : '.JText::_('EZAUTOS_AVAIL_SOLD').'<br />';
			}elseif($auto->availability == 4){
				$details .= JText::_('EZAUTOS_CATEGORY_CATNAME').' : '.JText::_('EZAUTOS_AVAIL_OT').'<br />';
			}

			if($auto->tag == 1){
				$details .= JText::_('EZAUTOS_DET_CONDITION').' : '.JText::_('EZAUTOS_TAGIT_NEW').'<br />';
			}elseif($auto->tag == 2){
				$details .= JText::_('EZAUTOS_DET_CONDITION').' : '.JText::_('EZAUTOS_TAGIT_USED').'<br />';
			}elseif($auto->tag == 3){
				$details .= JText::_('EZAUTOS_DET_CONDITION').' : '.JText::_('EZAUTOS_TAGIT_DEMO').'<br />';
			}elseif($auto->tag == 4){
				$details .= JText::_('EZAUTOS_DET_CONDITION').' : '.JText::_('EZAUTOS_TAGIT_ASNEW').'<br />';
			}elseif($auto->tag == 5){
				$details .= JText::_('EZAUTOS_DET_CONDITION').' : '.JText::_('EZAUTOS_TAGIT_PRELUV').'<br />';
			}elseif($auto->tag == 6){
				$details .= JText::_('EZAUTOS_DET_CONDITION').' : '.JText::_('EZAUTOS_TAGIT_SPARE').'<br />';
			}

			if(!empty($auto->enginename)) $details .= JText::_('EZAUTOS_DET_ENGSIZE').' : '.strtoupper($auto->enginename).'<br />';

			if($auto->trans == 0){
				$details .= JText::_('EZAUTOS_DET_TRANSMISSION').' : '.JText::_('EZAUTOS_SPECS_DOORSNS').'<br />';
			}elseif($auto->trans == 1){
				$details .= JText::_('EZAUTOS_DET_TRANSMISSION').' : '.JText::_('EZAUTOS_TRANSTYPE_AUTO').'<br />';
			}elseif($auto->trans == 2){
				$details .= JText::_('EZAUTOS_DET_TRANSMISSION').' : '.JText::_('EZAUTOS_TRANSTYPE_MAN').'<br />';
			}elseif($auto->trans == 3){
				$details .= JText::_('EZAUTOS_DET_TRANSMISSION').' : '.JText::_('EZAUTOS_TRANSTYPE_SEMIA').'<br />';
			}elseif($auto->trans == 4){
				$details .= JText::_('EZAUTOS_DET_TRANSMISSION').' : '.JText::_('EZAUTOS_TRANSTYPE_CVT').'<br />';
			}elseif($auto->trans == 5){
				$details .= JText::_('EZAUTOS_DET_TRANSMISSION').' : '.JText::_('EZAUTOS_TRANSTYPE_OTH').'<br />';
			}

			if(!empty($auto->fuel)){
				$details .= JText::_('EZAUTOS_VLDET_FUEL').' : '.JText::_('EZAUTOS_FUEL_TYPE'.$auto->fuel).'<br />';
			}
			if(!empty($auto->colour)){
				$details .= JText::_('EZAUTOS_DETAILS_EXTCOLOUR').' : '.JText::_('EZAUTOS_COLOUR_TYPE'.$auto->colour).'<br />';
			}
			if(!empty($auto->intcolour)){
				$details .= JText::_('EZAUTOS_DETAILS_INTCOLOUR').' : '.JText::_('EZAUTOS_COLOUR_TYPE'.$auto->intcolour).'<br />';
			}
			if(!empty($auto->mileage_unit) && !empty($auto->odometer)){
				$details .= JText::_('EZAUTOS_DET_MILEAGE').' : '.$auto->odometer.' '.JText::_('EZAUTOS_SPECS_ODOMETER_TYPE'.$auto->mileage_unit).'<br />';
			}
			if(!empty($auto->doors)){
				$details .= JText::_('EZAUTOS_SPECS_DOORS').' : '.$auto->doors.'<br />';
			}
			if(!empty($auto->body)){
				$details .= JText::_('EZAUTOS_SPECS_BODY').' : '.JText::_('EZAUTOS_SPECS_BODY'.$auto->body).'<br />';
			}
			$details .= '</td></tr>';
			$varFields['{details}'] = $details;
			$result .= $details;
		}

		$result .= '</table></div>';


		//Check if the template exists...
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'ezauto.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'ezauto.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields), $varFields, $result);
		}

		//We remove the JS...
		$result = $this->acypluginsHelper->removeJS($result);

		//We have our content... lets check the pictures options
		$tag->maxheight = empty($tag->maxheight) ? 150 : $tag->maxheight;
		$tag->maxwidth = empty($tag->maxwidth) ? 150 : $tag->maxwidth;
		$result = $this->acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, 'autoez');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;
			if(empty($parameter->order)) $parameter->order = 'id,ASC';

			$allcats = explode('-', $parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$where = array();
			$where[] = 'ez_auto.published = 1';
			if(!empty($selectedArea)) $where[] = 'ez_auto.cid IN ('.implode(',', $selectedArea).')';
			if(!empty($parameter->model)) $where[] = 'ez_auto.moid = '.intval($parameter->model);
			if(!empty($parameter->make)) $where[] = 'ez_auto.maid = '.intval($parameter->make);

			if(!empty($parameter->filter) AND !empty($email->params['lastgenerateddate'])){
				if($parameter->filter == 'modify'){
					$where[] = 'ez_auto.`lastupdate` > '.intval($email->params['lastgenerateddate']);
				}else{
					$where[] = 'ez_auto.`listdate` >=\''.date('Y-m-d', $email->params['lastgenerateddate'] - date('Z')).'\'';
				}
			}

			$query = 'SELECT ez_auto.id FROM `#__ezautos` as ez_auto ';
			$query .= ' WHERE ('.implode(') AND (', $where).')';

			if(!empty($parameter->order)){
				$ordering = explode(',', $parameter->order);
				if($ordering[0] == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$query .= ' ORDER BY ez_auto.'.acymailing_secureField($ordering[0]).' '.acymailing_secureField($ordering[1]);
				}
			}

			$start = '';
			if(!empty($parameter->start)) $start = intval($parameter->start).',';
			if(empty($parameter->max)) $parameter->max = 100;
			$query .= ' LIMIT '.$start.(int)$parameter->max;

			$this->db->setQuery($query);
			$allAutos = acymailing_loadResultArray($this->db);

			if(!empty($parameter->min) AND count($allAutos) < $parameter->min){
				$return->status = false;
				$return->message = 'Not enough cars for the tag '.$oneTag.' : '.count($allAutos).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allAutos)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autoez.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autoez.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the article tag one after the other in a table as they are already sorted
					foreach($allAutos as $oneArticleId){
						$args = array();
						$args[] = 'ezautos:'.$oneArticleId;
						if(!empty($parameter->autotype)) $args[] = 'type:'.$parameter->autotype;
						if(!empty($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|', $args).'}';
					}
					$stringTag = $this->acypluginsHelper->getFormattedResult($arrayElements, $parameter);
				}
			}

			$this->tags[$oneTag] = $stringTag;
		}

		return $return;
	}
}//endclass